cf Round #632 (Div. 2)B. Kind Anton

2024-02-04 21:48
文章标签 round div cf 632 kind anton

本文主要是介绍cf Round #632 (Div. 2)B. Kind Anton,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

在这里插入图片描述
题目大意:给你俩个数组a,b,其中数组a只包含{-1,0,1}中的元素,问数组a能不能通过以下操作变成B:
操作:将a[i]的值加给a[j]且可以重复多次(1<=i<j<=n)
思路:由于数组a最多只有三个元素-1,0,1那我们只需要比较a[i]和b[i],若a[i] < b[i]说明a[i]需要变大,三个元素中只有加上1才能使a[i]变大,因此需要数组a在第i个元素之前出现过1;同理,若a[i] > b[i] 需要在下标i之前出现过-1,若不满足以上俩个条件,则输出false。
以下是代码:

#include <iostream>
#include<set>
using namespace std;
const int maxn = 1e5 + 10;
int a[maxn], b[maxn];
int main()
{int t;scanf("%d", &t);while(t--){multiset<int>ms;int n;scanf("%d", &n);for(int i = 1; i <= n; i++){scanf("%d", &a[i]);}for(int i = 1; i <= n; i++){scanf("%d", &b[i]);}if(a[1] != b[1])//第一个元素不能变化,先特判一下{printf("NO\n");}else{bool flag =  true;for(int i = 1; i <= n; i++){if(b[i] > a[i]){if(ms.find(1) == ms.end())//找不到1,则a不能变成b{printf("NO\n");flag = false;break;}}else if(b[i] < a[i]){if(ms.find(-1) == ms.end())//找不到-1,则a不能变成b{printf("NO\n");flag = false;break;}}ms.insert(a[i]);//把a[i]丢进去}if(flag)printf("YES\n");}}return 0;
}

这篇关于cf Round #632 (Div. 2)B. Kind Anton的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/678886

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

cf 164 C 费用流

给你n个任务,k个机器,n个任务的起始时间,持续时间,完成任务的获利 每个机器可以完成任何一项任务,但是同一时刻只能完成一项任务,一旦某台机器在完成某项任务时,直到任务结束,这台机器都不能去做其他任务 最后问你当获利最大时,应该安排那些机器工作,即输出方案 具体建图方法: 新建源汇S T‘ 对任务按照起始时间s按升序排序 拆点: u 向 u'连一条边 容量为 1 费用为 -c,

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

CF 508C

点击打开链接 import java.util.Arrays;import java.util.Scanner;public class Main {public static void main(String [] args){new Solve().run() ;} }class Solve{int bit[] = new int[608] ;int l

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

【CF】C. Glass Carving(二分 + 树状数组 + 优先队列 + 数组计数)

这题简直蛋疼死。。。。。 A了一下午 #include<cstdio>#include<queue>#include<cstring>#include<algorithm>using namespace std;typedef long long LL;const int maxn = 200005;int h,w,n;int C1[maxn],C2[maxn];int